﻿Public MustInherit Class BaseNotifyPropertyChanged
    Implements ComponentModel.INotifyPropertyChanged

    Private Event PropertyChanged As ComponentModel.PropertyChangedEventHandler Implements ComponentModel.INotifyPropertyChanged.PropertyChanged

    Protected Sub SetField(Of T)(ByRef field As T, value As T, <System.Runtime.CompilerServices.CallerMemberName> Optional propertyName As String = Nothing)
        If Not EqualityComparer(Of T).[Default].Equals(field, value) Then
            field = value
            RaisePropertyChanged(propertyName)
        End If
    End Sub
    Protected Sub RaisePropertyChanged(propertyName As String)
        RaiseEvent PropertyChanged(Me, New System.ComponentModel.PropertyChangedEventArgs(propertyName))
    End Sub
End Class